## Lazyr

Setup:
- Install Haxe 4.3+
- Install NodeJS

```
npm i light-server -g
npm i free-tex-packer-core -g --legacy-peer-deps
npm i ttf2woff -g
haxelib install all
haxelib git hxnodejs https://github.com/HaxeFoundation/hxnodejs.git
```

### Assets folder and atlas generator

Use `assets` folder for original textures, folder structure for atlas generation is:
- /assets/png-files -> will be generated as `res/res.png` (and `res.json`)
- /assets/popup/png-files -> will be generated as `res/res_popup.png`
- /assets/otherAtlasName/png-files -> will be generated as `res/res_otherAtlasName.png`

Use `Run Task > Generate atlases` to generate all atlases and update `build-resources.hxml` automatically.
Generator will cache folder metadata and will skip folders if they are not changed.
You can force atlas generation if `res/res_atlasName.png` will be not found.

Separate (mostly `jpg`) images should be inside `res/` and have `bg` prefix in names, to be added to `build-resources.hxml` on atlas generation.

For temp files you can use `/assets/_someName/` folder names, generator will skip folders with underscore prefix (and subfolders too).
Haxe compilation server will be restarted after successful atlas generation to update fields completion, and `build-resources.hxml` will be updated, so you only need to recompile project.

### Configuration

You can create and customize `/lazyr.json` file with these properties:

```json
{
	"texpacker": {
		"tinifyKey": "your_key",
		"padding": 1,
		"trimMode": "trim"
	}
}
```

`tinifyKey` can be requested [here](https://tinypng.com/developers).
`trimMode` can be "trim" or "crop".

You can control `trimMode` behaviour with `.trimMode-crop` / `.trimMode-trim` empty file in any atlas folder.
