import haxe.io.Path;

class Run {
	static function main()
		new Run();

	final projectPath:String;

	public function new() {
		var args = Sys.args();
		projectPath = Path.removeTrailingSlashes(args.pop());
		final khmDir = Sys.getCwd();
		final action = args[0];
		final type = args[1];
		if (action == "build" && type == "atlases") {
			Sys.command("haxe", [
				'tools/build-atlas.hxml',
				'-D', 'projectPath=$projectPath'
			]);
		}
		if (action == "build" && type == "audiosprite") {
			Sys.command("haxe", [
				'tools/build-auditor.hxml',
				'-D', 'projectPath=$projectPath'
			]);
		}
		if (action == "build" && type == "fonts") {
			Sys.command("haxe", [
				'tools/build-fontier.hxml',
				'-D', 'projectPath=$projectPath'
			]);
		}
		if (action == "migrate") {
			Sys.command("haxe", [
				'tools/build-migrant.hxml',
				'-D', 'projectPath=$projectPath'
			]);
		}
	}
}
