package khm;

private enum AlignPos {
	TopLeft;
	TopCenter;
	TopRight;
	CenterLeft;
	Center;
	CenterRight;
	BottomLeft;
	BottomCenter;
	BottomRight;
	Custom(x:Float, y:Float);
}

enum abstract Alignement(AlignPos) {
	var TopLeft = AlignPos.TopLeft;
	var TopCenter = AlignPos.TopCenter;
	var TopRight = AlignPos.TopRight;
	var CenterLeft = AlignPos.CenterLeft;
	var Center = AlignPos.Center;
	var CenterRight = AlignPos.CenterRight;
	var BottomLeft = AlignPos.BottomLeft;
	var BottomCenter = AlignPos.BottomCenter;
	var BottomRight = AlignPos.BottomRight;

	public inline function new(x:Float, y:Float) {
		this = Custom(x, y);
	}

	public var x(get, never):Float;
	public var y(get, never):Float;

	function get_x():Float {
		return switch this {
			case AlignPos.TopLeft: 0;
			case AlignPos.TopCenter: 0.5;
			case AlignPos.TopRight: 1;
			case AlignPos.CenterLeft: 0;
			case AlignPos.Center: 0.5;
			case AlignPos.CenterRight: 1;
			case AlignPos.BottomLeft: 0;
			case AlignPos.BottomCenter: 0.5;
			case AlignPos.BottomRight: 1;
			case AlignPos.Custom(x, y): x;
		}
	}

	function get_y():Float {
		return switch this {
			case AlignPos.TopLeft: 0;
			case AlignPos.TopCenter: 0;
			case AlignPos.TopRight: 0;
			case AlignPos.CenterLeft: 0.5;
			case AlignPos.Center: 0.5;
			case AlignPos.CenterRight: 0.5;
			case AlignPos.BottomLeft: 1;
			case AlignPos.BottomCenter: 1;
			case AlignPos.BottomRight: 1;
			case AlignPos.Custom(x, y): y;
		}
	}

	public function toString():String {
		return this.getName();
	}
}
