package khm;

import khm.ResItem;

typedef Animation = {
	/** `[key]` - The key that the animation will be associated with. i.e. sprite.play(key). **/
	@:noCompletion var ?key:String;
	/** `[frames]` - Array of Animation Frame configuration objects. **/
	var frames:Array<ResItem>;
	/** `[sortFrames=true]` - If you provide a string for `frames` you can optionally have the frame names numerically sorted. **/
	var ?sortFrames:Bool;
	/** `[defaultTextureKey=null]` - The key of the texture all frames of the animation will use. Can be overridden on a per frame basis. **/
	@:noCompletion var ?defaultTextureKey:String;
	/** `[frameRate]` - The frame rate of playback in frames per second (default 24 if duration is null). **/
	var ?frameRate:Float;
	/** `[duration]` - How long the animation should play for in milliseconds. If not given its derived from frameRate. **/
	var ?duration:Float;
	/** `[skipMissedFrames=true]` - Skip frames if the time lags, or always advanced anyway? **/
	@:noCompletion var ?skipMissedFrames:Bool;
	/** `[delay=0]` - Delay before starting playback. Value given in milliseconds. **/
	var ?delay:Float;
	/** `[repeat=0]` - Number of times to repeat the animation (-1 for infinity). **/
	var ?repeat:Int;
	/** `[repeatDelay=0]` - Delay before the animation repeats. Value given in milliseconds. **/
	var ?repeatDelay:Float;
	/** `[yoyo=false]` - Should the animation yoyo? (reverse back down to the start) before repeating? **/
	var ?yoyo:Bool;
	/** `[showOnStart=false]` - Should sprite.visible = true when the animation starts to play? **/
	var ?showOnStart:Bool;
	/** `[hideOnComplete=false]` - Should sprite.visible = false when the animation finishes? **/
	var ?hideOnComplete:Bool;
	var ?onComplete:() -> Void;
};
