package khm;

import khm.Types.Rect;

class Camera {
	public final scene:Scene;
	public final viewport = new CameraViewport();

	public function new(scene:Scene) {
		this.scene = scene;
	}

	public var x = 0.0;
	public var y = 0.0;
	public var originX = 0.0;
	public var originY = 0.0;
	public var scaleX(default, set) = 1.0;
	public var scaleY(default, set) = 1.0;
	public var scale(get, set):Float;

	inline function set_scaleX(v:Float):Float {
		return this.scaleX = v;
	}

	inline function set_scaleY(v:Float):Float {
		return this.scaleY = v;
	}

	@:noCompletion inline function get_scale():Float {
		return (scaleX + scaleY) / 2;
	}

	@:noCompletion inline function set_scale(scale:Float):Float {
		scaleX = scale;
		scaleY = scale;
		return scale;
	}

	public var width(get, set):Float;

	inline function get_width():Float {
		return viewport.width / scaleX;
	}

	inline function set_width(w:Float):Float {
		return scaleX = w / viewport.width;
	}

	public var height(get, set):Float;

	inline function get_height():Float {
		return viewport.height / scaleY;
	}

	inline function set_height(h:Float):Float {
		return scaleY = h / viewport.height;
	}
}

class CameraViewport {
	public function new() {}

	public var isCustomSize = false;
	public var x = 0.0;
	public var y = 0.0;
	@:isVar public var width(get, set):Float;
	@:isVar public var height(get, set):Float;

	inline function get_width():Float {
		return isCustomSize ? width : App.w;
	}

	inline function set_width(width:Float):Float {
		isCustomSize = true;
		return this.width = width;
	}

	inline function get_height():Float {
		return isCustomSize ? height : App.h;
	}

	inline function set_height(height:Float):Float {
		isCustomSize = true;
		return this.height = height;
	}
}
