package khm;

private class ResTools {
	static final matchNumEnd = ~/[0-9]+$/g;

	public static function replaceNum(id:ResItem, ?n:Int):ResItem {
		if (!matchNumEnd.match(id.frame)) {
			throw 'id ${id.texture}.${id.frame} does not end with number';
		}
		final newNum = n == null ? "" : '$n';
		return {
			frame: matchNumEnd.replace(id.frame, newNum),
			texture: id.texture
		}
	}

	public static function replaceFrame(id:ResItem, match:String, by:String):ResItem {
		return {
			frame: id.frame.replace(match, by),
			texture: id.texture
		}
	}
}

@:using(khm.ResItem.ResTools)
typedef ResItem = {
	final frame:String;
	final texture:String;
}
