package khm;

typedef Point = {
	x:Float,
	y:Float
}

typedef IPoint = {
	x:Int,
	y:Int
}

typedef Size = {
	w:Float,
	h:Float
}

typedef ISize = {
	w:Int,
	h:Int
}

@:using(khm.Types.RectTools)
typedef Rect = Point & Size;

typedef IRect = IPoint & ISize;

@:structInit
class Range {
	public var start:Float;
	public var end:Float;

	public function lerp(ratio:Float):Float {
		return start + ratio * (end - start);
	}
}

@:structInit
class MinMax {
	public var min:Float;
	public var max:Float;

	public function randomInt():Int {
		final min = Math.ceil(min);
		final max = Math.floor(max);
		return Math.floor(Math.random() * (max - min + 1)) + min;
	}

	public function lerp(ratio:Float):Float {
		return min + ratio * (max - min);
	}
}

private class RectTools {
	public static inline function center(r:Rect):Point {
		return {
			x: r.x + r.w / 2,
			y: r.y + r.h / 2,
		};
	}

	public static inline function copy(r:Rect):Rect {
		return {
			x: r.x,
			y: r.y,
			w: r.w,
			h: r.h,
		};
	}
}
