package khm.ds;

import khm.Types.IPoint;

abstract IPointArray(Array<Int>) from Array<Int> {
	static inline var l = 2;

	public inline function new() {
		this = [];
	}

	public var length(get, never):Int;

	public inline function get_length():Int {
		return Std.int(this.length / l);
	}

	public inline function push(p:IPoint):Void {
		this.push(p.x);
		this.push(p.y);
	}

	public inline function pop():IPoint {
		final y = this.pop();
		final x = this.pop();
		return {x: x, y: y};
	}

	public inline function unshift(p:IPoint):Void {
		this.unshift(p.y);
		this.unshift(p.x);
	}

	public inline function shift():IPoint {
		final x = this.shift();
		final y = this.shift();
		return {x: x, y: y};
	}

	@:arrayAccess
	public inline function get(i:Int):IPoint {
		return {x: this[i * l], y: this[i * l + 1]};
	}

	public inline function resize(length:Int) {
		this.resize(length * l);
	}

	// public inline function toString():Array<IPoint> {
	// 	return [
	// 		for (i in 0...length) get(i)
	// 	];
	// }
	// @:to
	public inline function toIterable():Iterable<IPoint> {
		return [
			for (p in abstract) p
		];
	}

	public inline function iterator():IPointArrayIterator {
		return new IPointArrayIterator(abstract);
	}
}

private class IPointArrayIterator {
	final arr:IPointArray;
	var i = 0;

	public inline function new(arr:IPointArray) {
		this.arr = arr;
	}

	public inline function hasNext() {
		return i < arr.length;
	}

	public inline function next() {
		final point = arr.get(i);
		i++;
		return point;
	}
}
