package khm.math;

abstract Radians(Float) from Float {
	public inline function new(f:Float) {
		this = f;
	}

	@:op(-A) function neg():Radians;

	@:op(A > B) function gt(b:Radians):Bool;

	@:op(A >= B) function gte(b:Radians):Bool;

	@:op(A < B) function lt(b:Radians):Bool;

	@:op(A <= B) function lte(b:Radians):Bool;

	@:op(A == B) function eq(b:Radians):Bool;

	@:commutative
	@:op(A + B) static function add(a:Radians, b:Float):Radians;

	@:commutative
	@:op(A - B) static function sub(a:Radians, b:Float):Radians;

	@:commutative
	@:op(A * B) static function mult(a:Radians, b:Float):Radians;

	@:commutative
	@:op(A / B) static function div(a:Radians, b:Float):Radians;

	@:commutative
	@:op(A % B) static function mod(a:Radians, b:Float):Radians;

	public inline function sin():Float {
		return Math.sin(this);
	}

	public inline function cos():Float {
		return Math.cos(this);
	}

	public inline function toFloat():Float {
		return this;
	}

	public inline function toDeg():Degrees {
		return this.toDeg();
	}

	public inline function toString() {
		return '$this°';
	}
}
