package khm.tools;

class ColorTools {
	/** Create new color with zero alpha: `0xFF112233` will be `0x00112233`. **/
	public static function toRgb(color:Color):Color {
		return Color.fromBytes(color.Rb, color.Gb, color.Bb, 0);
	}

	/** Create css-compatible hex RGB string from color: `0x88FFFFFF` will be converted to `#FFFFFF`. **/
	public static function toRgbCode(color:Color):String {
		return "#" + StringTools.hex(color.toRgb(), 6);
	}

	/** Create css-compatible hex RGBA string from color: `0x88FFFFFF` will be converted to `rgba(255,255,255,0.533)`. **/
	public static function toRgbaCode(color:Color, trimZeroAlpha = false):String {
		var a = color.A;
		if (trimZeroAlpha && a == 0) a = 1;
		return 'rgba(${color.Rb},${color.Gb},${color.Bb},${a})';
	}
}
