package khm.tools;

class MultiStringTools {
	public static function chunkSubstr(str:String, size:Int):Array<String> {
		final numChunks = Math.ceil(str.length / size);
		final chunks = [];
		var o = 0;
		for (i in 0...numChunks) {
			chunks[i] = str.substr(o, size);
			o += size;
		}
		return chunks;
	}

	public static function align(text:String):String {
		final matchNonEmpty = ~/^[ \t]*[^ \t]/g;
		final matchIndents = ~/^[ \t]+/gm;
		final indents = RegexTools.getMatches(matchIndents, text);
		final min = indents.fold((a, b) -> {
			if (!matchNonEmpty.match(a)) return b;
			return a.length < b.length ? a : b;
		}, indents[0]);
		// final ereg = new EReg('^[ \\t]{1,${min.length}}', "gm");
		final ereg = new EReg('^$min', "gm");
		text = ereg.replace(text, "");
		return text;
	}

	public static function removeEmptyLines(text:String):String {
		return text.split("\n").filter(s -> s.rtrim().length > 0).join("\n");
	}

	public static function reverse(s:String):String {
		final arr = s.split("");
		arr.reverse();
		return arr.join("");
	}
}
