package khm.ui;

import khm.Event;
import khm.IGameObject;
import khm.ResItem;
import khm.ui.Widget;

@:structInit
class BoxOptions {
	public var padding = 6.0;
	public var child:IGameObject;
}

class Box extends Widget {
	final bg:NineSlice;
	final config:BoxOptions;

	public function new(bgFrame:ResItem, cornerSize:Int, config:BoxOptions, ?pos:DebugPosInfos) {
		super();
		this.setPosInfos(pos);
		this.config = config;
		bg = new NineSlice(bgFrame, cornerSize);
		add(bg);
		add(config.child);
	}

	override function build():Widget {
		final oldW = width;
		final oldH = height;
		width = context.maxW;
		height = context.maxH;
		if (width != oldW || height != oldH) {
			bg.width = width;
			bg.height = height;
			bg.x = width / 2;
			bg.y = height / 2;
		}

		final child = config.child;
		child.x = config.padding;
		child.y = config.padding;
		final child = child.toWidget() ?? return this;
		child.context.setFrom(context);
		child.context.maxW -= config.padding * 2;
		child.context.maxH -= config.padding * 2;
		child.build();

		return this;
	}
}
