package khm.ui;

import khm.Types.Rect;
import khm.Types.Size;
import khm.ui.Theme.ThemeData;

@:structInit
class BuildContext {
	public var theme:ThemeData = {};

	public var maxW = 0.0;
	public var maxH = 0.0;

	/** Crop properties apply when `widget.clipBehavior` is `Crop`. **/
	public var crop:Null<Rect> = null;

	/** Set values from another `context`. **/
	public function setFrom(context:BuildContext):Void {
		theme = context.theme;
		maxW = context.maxW;
		maxH = context.maxH;
		if (context.crop != null) {
			crop.x = context.crop.x;
			crop.y = context.crop.y;
			crop.w = context.crop.w;
			crop.h = context.crop.h;
		}
	}

	public function setCrop(x:Float, y:Float, w:Float, h:Float):Void {
		crop ??= {
			x: x,
			y: y,
			w: w,
			h: h,
		};
		crop.x = x;
		crop.y = y;
		crop.w = w;
		crop.h = h;
	}
}
