package khm.ui;

enum abstract ClipBehavior(Int) {
	/** Do not clip child when its rect overflowing parent rect. **/
	var None;

	/**
		Clip child when its rect is fully outside of parent, and crop object at render.

		So, you will see only part of child, that's fits into the parent rect.

		Has performance overhead.
	**/
	var Crop;

	/** Clip child when its rect can't fit parent. Child will fully disappear even with 1px overflow. **/
	var Strict;

	/**
		Like with `Crop`, clip child when its rect can't fit parent, but, in comparison, do not crop object at render.

		So, you will see object overflowing, before it completely goes outside the parent rect.
	**/
	var Loose;
}
