package khm.ui;

import khm.Types.Size;
import khm.ui.utils.FlexBase;

using khm.ui.WidgetTools;

@:structInit
class ColumnOptions {
	public var children:Array<IGameObject>;
	@:inheritDoc(MainAxisAlignment)
	public var mainAxisAlign = MainAxisAlignment.Start;
	@:inheritDoc(CrossAxisAlignment)
	public var crossAxisAlign = CrossAxisAlignment.Center;
	public var scrollable = false;
}

class Column extends FlexBase {
	final config:ColumnOptions;

	public function new(config:ColumnOptions, ?pos:DebugPosInfos) {
		super(Vertical);
		this.setPosInfos(pos);
		this.config = config;
		config.children ??= [];
		isScrollable = config.scrollable;

		for (object in config.children) add(object);
	}

	override function build():Widget {
		width = context.maxW;
		height = context.maxH;

		rebuildChildren();

		updateFlexChildrenSizes();

		final max = getMaxChildrenSize();
		var maxW = max.w;
		var maxH = max.h;
		width = maxW;
		// height = maxH;
		if (height < maxH) height = maxH;

		final totalSpace = height - maxH;
		var mainSize = 0.0;
		for (i => obj in children) {
			obj.y = mainSize;
			mainSize += obj.height;
			obj.y += getMainAxisOffset(i, config.mainAxisAlign, totalSpace);
		}

		for (obj in children) {
			obj.x = getCrossAxisPos(obj, config.crossAxisAlign, maxW, maxH);
		}

		clipChildren();

		return this;
	}
}
