package khm.ui;

/**
	The `crossAxisAlign` property determines how `Row` and `Column` can position
	their children on their cross axes.

	A `Row`'s cross axis is vertical, and a `Column`'s cross axis is horizontal.
**/
enum abstract CrossAxisAlignment(Int) {
	/** Positions children near the start of the cross axis (Top for `Row`, Left for `Column`). **/
	var Start;
	/** Positions children near the end of the cross axis (Bottom for `Row`, Right for `Column`). **/
	var End;
	/** Positions children at the middle of the cross axis (Middle for `Row`, Center for `Column`). **/
	var Center;
	/** Stretches children across the cross axis (Top-to-bottom for `Row`, left-to-right for `Column`). **/
	@:noCompletion var Stretch;
}
