package khm.ui;

import khm.Res;

@:structInit
class DividerOptions {
	public var padding = 0.0;
	public var axis = Axis.Horizontal;
	public var color:Null<Color> = null;
	public var width:Float = -1;
	public var height:Float = -1;
}

class Divider extends Widget {
	final line:Sprite;
	final config:DividerOptions;

	public function new(frame:ResItem, ?opts:DividerOptions, ?pos:DebugPosInfos) {
		super();
		this.setPosInfos(pos);
		opts ??= {};
		config = opts;

		line = addSprite(frame);
	}

	override function build():Widget {
		final padding = config.padding;
		line.x = padding;
		line.y = padding;
		line.tint = config.color ?? context.theme.bgColorDim;

		width = config.width;
		height = config.height;
		switch config.axis {
			case Horizontal:
				line.setOrigin(0);
				if (width == -1) width = context.maxW;
				if (height == -1) height = 1;
				height += padding * 2;

				line.displayWidth = width - padding * 2;
				line.displayHeight = height - padding * 2;

			case Vertical:
				line.setOrigin(0, 1);
				if (height == -1) height = context.maxH;
				if (width == -1) width = 1;
				width += padding * 2;

				line.angle = 90;
				line.displayWidth = height - padding * 2;
				line.displayHeight = width - padding * 2;
		}

		return this;
	}
}
