package khm.ui;

/**
	Suggests child to use all available space, instead of only required by child content.
**/
class Expanded extends Widget {
	var child:IGameObject;

	public function new(child:IGameObject, flexFactor = 1.0, ?pos:DebugPosInfos) {
		super();
		this.setPosInfos(pos);
		this.child = child;
		this.flexFactor = flexFactor;
		add(child);
	}

	override function build():Widget {
		width = context.maxW;
		height = context.maxH;

		final child = child.toWidget() ?? return this;
		child.context.setFrom(context);
		child.build();
		// if child does not want all space, shrink
		if (width > child.width) width = child.width;
		if (height > child.height) height = child.height;
		return this;
	}
}
