package khm.ui;

import khm.ui.utils.FlexBase;

using khm.ui.WidgetTools;

@:structInit
class RowOptions {
	public var children:Array<IGameObject>;
	@:inheritDoc(MainAxisAlignment)
	public var mainAxisAlign = MainAxisAlignment.Start;
	@:inheritDoc(CrossAxisAlignment)
	public var crossAxisAlign = CrossAxisAlignment.Center;
}

class Row extends FlexBase {
	public final config:RowOptions;

	public function new(config:RowOptions, ?pos:DebugPosInfos) {
		super(Horizontal);
		this.setPosInfos(pos);
		this.config = config;
		config.children ??= [];

		for (object in config.children) add(object);
	}

	override function build():Widget {
		width = context.maxW;
		height = context.maxH;

		rebuildChildren();

		updateFlexChildrenSizes();

		final max = getMaxChildrenSize();
		var maxW = max.w;
		var maxH = max.h;
		if (width < maxW) width = maxW;
		// width = maxW;
		height = maxH;

		final totalSpace = width - maxW;
		var mainSize = 0.0;
		for (i => obj in children) {
			obj.x = mainSize;
			mainSize += obj.width;
			obj.x += getMainAxisOffset(i, config.mainAxisAlign, totalSpace);
		}

		for (obj in children) {
			obj.y = getCrossAxisPos(obj, config.crossAxisAlign, maxW, maxH);
		}

		clipChildren();

		return this;
	}
}
