package khm.ui;

@:structInit
class ThemeData {
	public var primaryColor:Color = 0xFFFFFFFF;
	public var primaryColorDim:Color = 0xFF999999;
	public var secondaryColor:Color = 0xFFFFFFFF;
	public var secondaryColorDim:Color = 0xFF999999;
	public var bgColor:Color = 0xFF222222;
	public var bgColorDim:Color = 0xFF000000;
	public var accentColor:Color = 0xFF006EFF;
	// public var accentColorDim:Color = 0xFF003EAA;
}

@:structInit
class ThemeOptions {
	public var theme:ThemeData;
	public var child:IGameObject;
}

class Theme extends Widget {
	final config:ThemeOptions;

	public function new(config:ThemeOptions, ?pos:DebugPosInfos) {
		super();
		this.config = config;
		this.setPosInfos(pos);
		context.theme = config.theme ?? {};
		add(config.child);
	}

	override function build():Widget {
		width = context.maxW;
		height = context.maxH;

		final child = config.child;
		final child = child.toWidget() ?? return this;
		child.context.setFrom(context);
		child.build();

		return this;
	}
}
