package khm.ui;

import khm.IContainer.Children;
import khm.ui.utils.FlexBase;

using khm.ui.WidgetTools;

class WidgetTools {
	public static function hasFlexFactor(obj:IGameObject):Bool {
		final obj = obj.toWidget() ?? return false;
		return obj.flexFactor != 0;
	}

	public static function getTotalFlex(children:Children):Float {
		var sum = 0.0;
		for (obj in children) {
			if (!obj.hasFlexFactor()) continue;
			final obj = obj.toWidget();
			sum += obj.flexFactor;
		}
		return sum;
	}

	public static function isExpanded(widget:Null<Widget>):Bool {
		return widget != null && widget is Expanded;
	}

	public static function isRow(widget:Null<Widget>):Bool {
		if (widget == null) return false;
		if (!(widget is FlexBase)) return false;
		final flex:FlexBase = cast widget;
		return flex.mainAxis == Horizontal;
	}

	public static function isColumn(widget:Null<Widget>):Bool {
		if (widget == null) return false;
		if (!(widget is FlexBase)) return false;
		final flex:FlexBase = cast widget;
		return flex.mainAxis == Vertical;
	}
}
