package khm.utils.js;

#if js
import js.Browser.document;
import js.html.Event;
#end

private typedef Callback = (text:Null<String>) -> Bool;

class Modal {
	#if js
	public static function prompt(name:String, data:String, callback:Callback):Void {
		final modal = document.createElement("div");
		final form = document.createTextAreaElement();
		final style = document.createStyleElement();

		inline function onClose(e:Event):Void {
			document.body.removeChild(modal);
			document.body.removeChild(style);
			e.stopPropagation();
			final canvas = document.querySelector('canvas');
			canvas.focus();
		}
		function onCancel(e:Event):Void {
			final isClose = callback(null);
			if (isClose) onClose(e);
		}
		function onSave(e:Event):Void {
			final isClose = callback(form.value);
			if (isClose) onClose(e);
		}
		modal.className = "modal";
		modal.onclick = onCancel;

		final content = document.createElement("div");
		content.className = "modal-content";
		content.onclick = function(e) {
			e.stopPropagation();
		}

		final title = document.createElement("div");
		title.textContent = name;
		form.style.width = "100%";
		form.rows = 15;
		form.value = data;
		final cancel = document.createButtonElement();
		cancel.innerHTML = "Cancel";
		cancel.onclick = onCancel;
		final save = document.createButtonElement();
		save.innerHTML = "Save";
		save.onclick = onSave;

		content.appendChild(title);
		content.appendChild(form);
		content.appendChild(document.createElement("br"));
		content.appendChild(cancel);
		content.appendChild(save);
		modal.appendChild(content);
		document.body.appendChild(modal);
		style.innerHTML = "
		.modal {
			position: absolute;
			z-index: 1;
			padding-top: 100px;
			left: 0;
			top: 0;
			width: 100%;
			height: 100%;
			overflow: auto;
			background-color: rgb(0, 0, 0);
			background-color: rgba(0, 0, 0, 0.4);
		}

		.modal-content {
			background-color: #fefefe;
			margin: auto;
			padding: 20px;
			border: 1px solid #888;
			width: 80%;
		}";
		document.body.appendChild(style);
	}
	#else
	public static function prompt(name:String, data:String, callback:Callback):Void {
		callback(null);
	}
	#end
}
