package khm.utils.macro;

import haxe.macro.Context;
import haxe.macro.Expr;
import haxe.macro.Printer;
import haxe.macro.Type;

using haxe.macro.Tools;

class TypedefUtils {
	macro public static function getFields(td:Expr):Expr {
		final names:Array<String> = [];
		final type = Context.getType(td.toString()).followWithAbstracts();
		switch type {
			case TAnonymous(a):
				for (field in a.get().fields) {
					var name = field.name;
					names.push(name);
				}
			default:
				throw 'Argument should be typedef type $type';
		}
		return macro $v{names};
	}
}
