package khm.verlet;

import khm.math.Vector2;

class Blob extends Body {
	public function new(world:World, x:Float, y:Float, radius:Float, mass = 1.0) {
		super(world, {
			mass: mass,
			type: Polygon,
			dots: [],
			constraints: []
		});

		final n = 25; // number of dots
		final delta = Math.PI * 2 / n;
		var ang = 0.0;
		for (i in 0...n) {
			final dx = x + Math.cos(ang) * radius;
			final dy = y + Math.sin(ang) * radius;
			addDot(dx, dy);
			ang += delta;
		}
		inline function dist(v1:Vector2, v2:Vector2) {
			final dx = v1.x - v2.x;
			final dy = v1.y - v2.y;
			return Math.sqrt(dx * dx + dy * dy);
		}
		for (i in 0...n) {
			var isEdge = true;
			for (j in i + 1...n) {
				final d = dist(dots[i].pos, dots[j].pos);
				if (d == 0) continue;
				addConstraint(dots[i], dots[j], 0.02, isEdge);
				isEdge = false;
				if (i == 0 && j == i + (n - 2)) isEdge = true;
			}
		}
		updateBoundingBox();
	}
}
