package khm.verlet;

import khm.math.Vector2;

class DotUtils {
	public static function isConcave(dots:Array<Dot>, isClockwise = true):Bool {
		final length = dots.length;
		if (length < 3) return false;

		for (i => dot in dots) {
			final i2 = (i + 1) % length;
			final i3 = (i + 2) % length;
			final v = dot.pos;
			final v2 = dots[i2].pos;
			final v3 = dots[i3].pos;
			final z = (v2.x - v.x) * (v3.y - v2.y) - (v2.y - v.y) * (v3.x - v2.x);
			if (z < 0) {
				if (isClockwise) return true;
			} else if (z > 0) {
				if (!isClockwise) return true;
			}
		}
		return false;
	}
}
