package khm.verlet;

@:structInit
class TriangleOptions {
	public var mass = 1.0;
	public var fixed = false;
	public var stiffness = 1.0;
}

class Triangle extends Body {
	public function new(world:World, x:Float, y:Float, x2:Float, y2:Float, x3:Float, y3:Float, ?config:TriangleOptions) {
		config ??= {};
		if (config.fixed) fixed = true;
		super(world, {
			mass: config.mass,
			dots: [
				{x: x, y: y, fixed: config.fixed},
				{x: x2, y: y2, fixed: config.fixed},
				{x: x3, y: y3, fixed: config.fixed},
			],
			constraints: []
		});
		generateEdges(config.stiffness);
	}
}
