package phaser.types.tweens;

import haxe.extern.EitherType as Or;
import phaser.gameobjects.GameObject;
import phaser.tweens.Tween;

/**
 * @callback Phaser.Types.Tweens.TweenOnStartCallback
 * @since 3.18.0
 *
 * @param {Phaser.Tweens.Tween} tween - The tween.
 * @param {array} targets - The tween targets.
 * @param {...any} param - Any value passed in `onStartParams`.
 */
typedef TweenOnStartCallback = Or<Or<() -> Void,
	(tween:Tween, targets:Array<GameObject>) -> Void>,
	(tween:Tween) -> Void>;
