package phaser.types.tweens;

import haxe.extern.EitherType as Or;
import phaser.gameobjects.GameObject;
import phaser.tweens.Tween;

/**
 * @callback Phaser.Types.Tweens.TweenOnUpdateCallback
 * @since 3.18.0
 *
 * @param {Phaser.Tweens.Tween} tween - The tween.
 * @param {any} target - The tween target.
 * @param {...any} param - Any value passed in `onUpdateParams`.
 */
typedef TweenOnUpdateCallback = Or<Or<() -> Void, (tween:Tween) -> Void>,
	(tween:Tween, target:Array<GameObject>) -> Void>;
