package tests;

import Main.GlobalScene;
import haxe.PosInfos;
import haxe.Timer;
import khm.App;
import khm.Lazyr.*;
import khm.Lazyr;
import khm.Scene;
import phaser.types.core.GameConfig;
import utest.Assert;
import utest.Async;
import utest.Test;

class TestTween extends Test {
	@:timeout(500)
	function testMain(async:Async) {
		init(() -> {
			final scene = new Scene();
			App.init({
				scene: scene,
			});
			final order = [];
			delayed(0, () -> order.push(1));
			order.push(2);
			delayed(1, () -> order.push(4));
			order.push(3);
			Assert.same([1, 2, 3], order);
			delayed(60, () -> order.push(6));
			delayed(30, () -> order.push(5));
			delayed(90, () -> {
				Assert.same([1, 2, 3, 4, 5, 6], order);
				async.done();
			});
		});
	}

	function almostEq(a:Float, b:Float, ?pos:PosInfos):Void {
		// if (isMacCI() || isWindowsCI()) {
		// 	Assert.isTrue(Math.abs(a - b) < 0.5);
		// 	return;
		// }
		Assert.equals(Math.round(a * 10) / 10, Math.round(b * 10) / 10, pos);
	}

	// function isMacCI():Bool {
	// 	return Sys.systemName() == "Mac" && Sys.environment()["CI"] == "true";
	// }
	// function isWindowsCI():Bool {
	// 	return Sys.systemName() == "Windows" && Sys.environment()["CI"] == "true";
	// }

	static function init(callback:() -> Void):Void {
		final config:GameConfig = {
			#if canvas_only
			type: untyped Phaser.CANVAS,
			#end
			parent: "canvas-game",
			autoFocus: true,
			canvasStyle: "display: block; width: 100%; height: 100%;",
			#if debug
			render: {
				clearBeforeRender: false,
				powerPreference: 'low-power'
			},
			#end
			scene: new GlobalScene(_scene -> {
				App._scene = _scene;
				callback();
			})
		}
		final game = new phaser.Game(config);
	}
}
