// Generated by Haxe 4.3.6
(function ($global) { "use strict";
var Auditor = function() { };
Auditor.__name__ = true;
Auditor.main = function() {
	var audiospriteModule;
	try {
		var buffer = js_node_ChildProcess.execSync("npm root --location=global");
		var path = StringTools.trim(buffer.toString());
		audiospriteModule = require((path + "/audiosprite/audiosprite.js"));
	} catch( _g ) {
		console.log("Install audiosprite globally first: check out README.md");
		process.exit(1);
		return;
	}
	var projectPath = "/Users/maxim/Projects/Khm/AgainstTheWall";
	var assetsPath = "" + projectPath + "/assets/_audio";
	if(!sys_FileSystem.exists(assetsPath)) {
		console.log("Folder " + StringTools.replace(assetsPath,projectPath,"") + " not found");
		return;
	}
	var audiosprite = $bind(audiospriteModule,audiospriteModule);
	var formats = ["mp3","ogg","wav","ac3","m4a","mp4"];
	var _this = js_node_Fs.readdirSync(assetsPath);
	var _g = [];
	var _g1 = 0;
	while(_g1 < _this.length) {
		var v = _this[_g1];
		++_g1;
		if(StringTools.startsWith(v,".") ? false : sys_FileSystem.isDirectory("" + assetsPath + "/" + v) ? false : formats.indexOf(haxe_io_Path.extension(v)) != -1) {
			_g.push(v);
		}
	}
	var result = new Array(_g.length);
	var _g1 = 0;
	var _g2 = _g.length;
	while(_g1 < _g2) {
		var i = _g1++;
		result[i] = "" + assetsPath + "/" + _g[i];
	}
	var result1 = new Array(result.length);
	var _g = 0;
	var _g1 = result.length;
	while(_g < _g1) {
		var i = _g++;
		result1[i] = Auditor.getFileName(result[i]);
	}
	var loops = [];
	console.log("Tracks names: " + result1.join(", "));
	var _g = 0;
	while(_g < result1.length) {
		var name = result1[_g];
		++_g;
		if(StringTools.startsWith(name,"music_") || name == "music") {
			loops.push(name);
		}
	}
	if(loops.length == 0) {
		console.log("No looped tracks (files with 'music_' prefix)");
	} else {
		console.log("Looped tracks: " + loops.join(", "));
	}
	audiosprite(result,{ output : "" + projectPath + "/res/audio", loop : loops, 'export' : "mp3", path : "" + projectPath + "/res", bitrate : 64},function(err,json) {
		if(err != null) {
			console.log("Error: " + Std.string(err));
			return;
		}
		var content = JSON.stringify(json);
		js_node_Fs.writeFileSync("" + projectPath + "/res/audio.json",content);
		var stat = js_node_Fs.statSync("" + projectPath + "/res/audio.mp3");
		var kb = stat.size / 1024 | 0;
		console.log("\nres/audio.mp3 updated (" + kb + " KiB)");
		console.log("\n");
	});
};
Auditor.getFileName = function(path) {
	return haxe_io_Path.withoutDirectory(haxe_io_Path.withoutExtension(path));
};
var HxOverrides = function() { };
HxOverrides.__name__ = true;
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) {
		return undefined;
	}
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(len == null) {
		len = s.length;
	} else if(len < 0) {
		if(pos == 0) {
			len = s.length + len;
		} else {
			return "";
		}
	}
	return s.substr(pos,len);
};
HxOverrides.now = function() {
	return Date.now();
};
Math.__name__ = true;
var Std = function() { };
Std.__name__ = true;
Std.string = function(s) {
	return js_Boot.__string_rec(s,"");
};
var StringTools = function() { };
StringTools.__name__ = true;
StringTools.startsWith = function(s,start) {
	if(s.length >= start.length) {
		return s.lastIndexOf(start,0) == 0;
	} else {
		return false;
	}
};
StringTools.isSpace = function(s,pos) {
	var c = HxOverrides.cca(s,pos);
	if(!(c > 8 && c < 14)) {
		return c == 32;
	} else {
		return true;
	}
};
StringTools.ltrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,r)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,r,l - r);
	} else {
		return s;
	}
};
StringTools.rtrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,l - r - 1)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,0,l - r);
	} else {
		return s;
	}
};
StringTools.trim = function(s) {
	return StringTools.ltrim(StringTools.rtrim(s));
};
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
};
var haxe_io_Path = function(path) {
	switch(path) {
	case ".":case "..":
		this.dir = path;
		this.file = "";
		return;
	}
	var c1 = path.lastIndexOf("/");
	var c2 = path.lastIndexOf("\\");
	if(c1 < c2) {
		this.dir = HxOverrides.substr(path,0,c2);
		path = HxOverrides.substr(path,c2 + 1,null);
		this.backslash = true;
	} else if(c2 < c1) {
		this.dir = HxOverrides.substr(path,0,c1);
		path = HxOverrides.substr(path,c1 + 1,null);
	} else {
		this.dir = null;
	}
	var cp = path.lastIndexOf(".");
	if(cp != -1) {
		this.ext = HxOverrides.substr(path,cp + 1,null);
		this.file = HxOverrides.substr(path,0,cp);
	} else {
		this.ext = null;
		this.file = path;
	}
};
haxe_io_Path.__name__ = true;
haxe_io_Path.withoutExtension = function(path) {
	var s = new haxe_io_Path(path);
	s.ext = null;
	return s.toString();
};
haxe_io_Path.withoutDirectory = function(path) {
	var s = new haxe_io_Path(path);
	s.dir = null;
	return s.toString();
};
haxe_io_Path.extension = function(path) {
	var s = new haxe_io_Path(path);
	if(s.ext == null) {
		return "";
	}
	return s.ext;
};
haxe_io_Path.prototype = {
	toString: function() {
		return (this.dir == null ? "" : this.dir + (this.backslash ? "\\" : "/")) + this.file + (this.ext == null ? "" : "." + this.ext);
	}
};
var haxe_iterators_ArrayIterator = function(array) {
	this.current = 0;
	this.array = array;
};
haxe_iterators_ArrayIterator.__name__ = true;
haxe_iterators_ArrayIterator.prototype = {
	hasNext: function() {
		return this.current < this.array.length;
	}
	,next: function() {
		return this.array[this.current++];
	}
};
var js_Boot = function() { };
js_Boot.__name__ = true;
js_Boot.__string_rec = function(o,s) {
	if(o == null) {
		return "null";
	}
	if(s.length >= 5) {
		return "<...>";
	}
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) {
		t = "object";
	}
	switch(t) {
	case "function":
		return "<function>";
	case "object":
		if(((o) instanceof Array)) {
			var str = "[";
			s += "\t";
			var _g = 0;
			var _g1 = o.length;
			while(_g < _g1) {
				var i = _g++;
				str += (i > 0 ? "," : "") + js_Boot.__string_rec(o[i],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( _g ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") {
				return s2;
			}
		}
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		var k = null;
		for( k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) {
			str += ", \n";
		}
		str += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "string":
		return o;
	default:
		return String(o);
	}
};
var js_node_ChildProcess = require("child_process");
var js_node_Fs = require("fs");
var sys_FileSystem = function() { };
sys_FileSystem.__name__ = true;
sys_FileSystem.exists = function(path) {
	try {
		js_node_Fs.accessSync(path);
		return true;
	} catch( _g ) {
		return false;
	}
};
sys_FileSystem.isDirectory = function(path) {
	try {
		return js_node_Fs.statSync(path).isDirectory();
	} catch( _g ) {
		return false;
	}
};
var $_;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $global.$haxeUID++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = m.bind(o); o.hx__closures__[m.__id__] = f; } return f; }
$global.$haxeUID |= 0;
if(typeof(performance) != "undefined" ? typeof(performance.now) == "function" : false) {
	HxOverrides.now = performance.now.bind(performance);
}
String.__name__ = true;
Array.__name__ = true;
js_Boot.__toStr = ({ }).toString;
Auditor.main();
})(typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this);
