// Generated by Haxe 4.3.6
(function ($global) { "use strict";
var $estr = function() { return js_Boot.__string_rec(this,''); },$hxEnums = $hxEnums || {},$_;
function $extend(from, fields) {
	var proto = Object.create(from);
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var EReg = function(r,opt) {
	this.r = new RegExp(r,opt.split("u").join(""));
};
EReg.__name__ = true;
EReg.prototype = {
	match: function(s) {
		if(this.r.global) {
			this.r.lastIndex = 0;
		}
		this.r.m = this.r.exec(s);
		this.r.s = s;
		return this.r.m != null;
	}
};
var GenAtlas = function() { };
GenAtlas.__name__ = true;
GenAtlas.main = function() {
	var projectPath = "/Users/maxim/Projects/Khm/AgainstTheWall";
	if(projectPath == null) {
		throw haxe_Exception.thrown("-D projectPath=... not found, use `haxelib run khm build atlases` from project folder");
	}
	var texturePackerModule;
	try {
		var buffer = js_node_ChildProcess.execSync("npm root --location=global");
		var path = StringTools.trim(buffer.toString());
		texturePackerModule = require((path + "/free-tex-packer-core"));
	} catch( _g ) {
		console.log("Install free-tex-packer-core globally first: check out README.md");
		process.exit(1);
		return;
	}
	var onlyAtlas = GenAtlas.valueOfArg(process.argv.slice(2),"--only");
	var atlasesPath = "" + projectPath + "/assets/atlases";
	var outPath = "" + projectPath + "/" + "res/atlases";
	var outBgPath = "" + projectPath + "/" + "res";
	GenAtlas.ensureDir(outPath);
	var folders = GenAtlas.getAtlasFolders(atlasesPath);
	if(onlyAtlas != null) {
		if(onlyAtlas == "res") {
			folders = [""];
		} else {
			var _g = [];
			var _g1 = 0;
			var _g2 = folders;
			while(_g1 < _g2.length) {
				var v = _g2[_g1];
				++_g1;
				if(v == onlyAtlas) {
					_g.push(v);
				}
			}
			folders = _g;
		}
	}
	var texOptions = GenAtlas.readLazyrConfig("" + projectPath + "/lazyr.json").texOptions;
	var promises = [];
	var _g = 0;
	while(_g < folders.length) {
		var folder = folders[_g];
		++_g;
		var assetsFolder = "" + atlasesPath + "/" + folder;
		var outFilePath = "" + outPath + "/res_" + folder;
		if(folder == "") {
			assetsFolder = "" + atlasesPath;
			outFilePath = "" + outPath + "/res";
		}
		if(sys_FileSystem.exists("" + outFilePath + ".json")) {
			if(!GenAtlas.checkDirHash(assetsFolder)) {
				continue;
			}
		}
		promises.push(GenAtlas.makeAtlas(assetsFolder,outFilePath,texturePackerModule,texOptions));
	}
	Promise.all(promises).then(function(_) {
		GenAtlas.updateHxml("" + projectPath + "/build-resources.hxml",outPath,outBgPath,atlasesPath);
		console.log("\n");
	});
};
GenAtlas.getAtlasFolders = function(atlasesPath) {
	var _this = js_node_Fs.readdirSync(atlasesPath);
	var _g = [];
	var _g1 = 0;
	while(_g1 < _this.length) {
		var v = _this[_g1];
		++_g1;
		if(StringTools.startsWith(v,".") || StringTools.startsWith(v,"_") ? false : sys_FileSystem.isDirectory("" + atlasesPath + "/" + v)) {
			_g.push(v);
		}
	}
	_g.push("");
	return _g;
};
GenAtlas.readLazyrConfig = function(path) {
	var config = { texOptions : { tinifyKey : "", padding : 1, trimMode : "trim", powerOfTwo : true}};
	if(!sys_FileSystem.exists(path)) {
		console.log("Warning: " + path + " not found, checkout README");
		return config;
	}
	var lazyr = JSON.parse(js_node_Fs.readFileSync(path,{ encoding : "utf8"}));
	if(lazyr == null) {
		return config;
	}
	var opts = lazyr.texpacker;
	if(opts == null) {
		return config;
	}
	if(opts.tinifyKey != null) {
		config.texOptions.tinifyKey = opts.tinifyKey;
	}
	if(opts.padding != null) {
		config.texOptions.padding = opts.padding;
	}
	if(opts.trimMode != null) {
		config.texOptions.trimMode = opts.trimMode;
	}
	if(opts.powerOfTwo != null) {
		config.texOptions.powerOfTwo = opts.powerOfTwo;
	}
	return config;
};
GenAtlas.valueOfArg = function(args,key) {
	var i = args.indexOf(key);
	if(i == -1) {
		return null;
	}
	return args[i + 1];
};
GenAtlas.isImageExtension = function(ext) {
	switch(ext) {
	case "jpeg":case "jpg":case "png":case "webp":
		return true;
	default:
		return false;
	}
};
GenAtlas.makeAtlas = function(folderPath,outFilePath,texturePackerModule,texOptions) {
	var texturePacker = $bind(texturePackerModule,texturePackerModule);
	var items = js_node_Fs.readdirSync(folderPath);
	var trimMode = texOptions.trimMode;
	if(items.indexOf(".trimMode-crop") != -1) {
		trimMode = "crop";
	}
	if(items.indexOf(".trimMode-trim") != -1) {
		trimMode = "trim";
	}
	var tinify = texOptions.tinifyKey == "" ? false : true;
	if(items.indexOf(".tinify-false") != -1) {
		tinify = false;
	}
	var _g = [];
	var _g1 = 0;
	var _g2 = items;
	while(_g1 < _g2.length) {
		var v = _g2[_g1];
		++_g1;
		if(sys_FileSystem.isDirectory("" + folderPath + "/" + v) ? false : StringTools.startsWith(v,".") ? false : GenAtlas.isImageExtension(haxe_io_Path.extension(v))) {
			_g.push(v);
		}
	}
	if(_g.length == 0) {
		return Promise.resolve();
	}
	var images = [];
	var _g1 = 0;
	while(_g1 < _g.length) {
		var name = _g[_g1];
		++_g1;
		images.push({ path : "" + folderPath + "/" + name, contents : js_node_Fs.readFileSync("" + folderPath + "/" + name)});
	}
	var promise = new Promise(function(resolve,reject) {
		texturePacker(images,{ textureName : haxe_io_Path.withoutDirectory(outFilePath), removeFileExtension : true, prependFolderName : false, tinify : tinify, tinifyKey : texOptions.tinifyKey, exporter : "Phaser3", padding : texOptions.padding, allowTrim : true, allowRotation : false, powerOfTwo : texOptions.powerOfTwo, trimMode : trimMode, packer : "OptimalPacker"},function(files,error) {
			if(error != null) {
				GenAtlas.removeDirHash(folderPath);
				var msg = "Error: packaging error for " + outFilePath + ".png";
				if(error.description != null) {
					msg += ":" + error.description;
				}
				console.log(msg);
				resolve(null);
				return;
			}
			var endsWithNum = new EReg("-[0-9]\\.","g");
			var outDir = haxe_io_Path.directory(outFilePath);
			var hasSkippedAtlases = false;
			GenAtlas.removeFolder("" + outDir + "/_skipped");
			var _g = 0;
			while(_g < files.length) {
				var item = files[_g];
				++_g;
				if(endsWithNum.match(item.name)) {
					if(StringTools.endsWith(item.name,".png")) {
						console.log("Skipped: " + item.name + ": too big atlas is splitted");
						GenAtlas.ensureDir("" + outDir + "/_skipped");
						js_node_Fs.writeFileSync("" + outDir + "/_skipped/" + item.name,item.buffer);
						hasSkippedAtlases = true;
					}
					continue;
				}
				js_node_Fs.writeFileSync("" + outDir + "/" + item.name,item.buffer);
				var size = js_node_Fs.statSync("" + outDir + "/" + item.name).size;
				if(StringTools.endsWith(item.name,".png")) {
					var size1 = PngDimensions.calculate(item.buffer);
					console.log(item.name,"" + (size / 1024 * 10 | 0) / 10 + " KiB","" + size1.width + "x" + size1.height);
				}
			}
			if(hasSkippedAtlases) {
				GenAtlas.removeDirHash(folderPath);
				console.log("Error: see splitted atlas textures in res/_skipped");
			}
			resolve(null);
		});
	});
	return promise;
};
GenAtlas.ensureDir = function(path) {
	if(!sys_FileSystem.exists(path)) {
		sys_FileSystem.createDirectory(path);
	}
};
GenAtlas.removeFolder = function(folderPath) {
	if(!sys_FileSystem.exists(folderPath)) {
		return;
	}
	var _g = 0;
	var _g1 = js_node_Fs.readdirSync(folderPath);
	while(_g < _g1.length) {
		var path = "" + folderPath + "/" + _g1[_g++];
		if(sys_FileSystem.isDirectory(path)) {
			continue;
		}
		js_node_Fs.unlinkSync(path);
	}
	if(sys_FileSystem.exists(folderPath)) {
		var _g = 0;
		var _g1 = js_node_Fs.readdirSync(folderPath);
		while(_g < _g1.length) {
			var curPath = folderPath + "/" + _g1[_g++];
			if(sys_FileSystem.isDirectory(curPath)) {
				if(sys_FileSystem.exists(curPath)) {
					var _g2 = 0;
					var _g3 = js_node_Fs.readdirSync(curPath);
					while(_g2 < _g3.length) {
						var curPath1 = curPath + "/" + _g3[_g2++];
						if(sys_FileSystem.isDirectory(curPath1)) {
							sys_FileSystem.deleteDirectory(curPath1);
						} else {
							js_node_Fs.unlinkSync(curPath1);
						}
					}
					js_node_Fs.rmdirSync(curPath);
				}
			} else {
				js_node_Fs.unlinkSync(curPath);
			}
		}
		js_node_Fs.rmdirSync(folderPath);
	}
};
GenAtlas.checkDirHash = function(folder) {
	if(process.argv.slice(2).indexOf("--force") != -1) {
		return true;
	}
	var hashStats = "";
	var items = js_node_Fs.readdirSync(folder);
	var _g = 0;
	while(_g < items.length) {
		var name = items[_g];
		++_g;
		if(StringTools.startsWith(name,".")) {
			continue;
		}
		var path = "" + folder + "/" + name;
		if(sys_FileSystem.isDirectory(path)) {
			continue;
		}
		var stat = js_node_Fs.statSync(path);
		hashStats += "" + path + ":" + stat.size + ":" + stat.mtime.getTime() + "\n";
	}
	var hash = haxe_crypto_Md5.encode(hashStats);
	var isFolderChanged = true;
	var cachePath = "" + folder + "/._atlas_hash";
	if(sys_FileSystem.exists(cachePath)) {
		isFolderChanged = js_node_Fs.readFileSync(cachePath,{ encoding : "utf8"}) != hash;
	}
	if(isFolderChanged) {
		js_node_Fs.writeFileSync(cachePath,hash);
	} else {
		console.log("Skip atlas generation for " + folder);
	}
	return isFolderChanged;
};
GenAtlas.removeDirHash = function(folder) {
	var cachePath = "" + folder + "/._atlas_hash";
	if(!sys_FileSystem.exists(cachePath)) {
		return;
	}
	js_node_Fs.unlinkSync(cachePath);
};
GenAtlas.updateHxml = function(hxmlPath,outPath,outBgPath,atlasesPath) {
	var hxmlName = haxe_io_Path.withoutDirectory(hxmlPath);
	if(!sys_FileSystem.exists(hxmlPath)) {
		console.log("/" + hxmlName + " not found to update");
		return;
	}
	var _this = js_node_Fs.readdirSync(outBgPath);
	var _g = [];
	var _g1 = 0;
	while(_g1 < _this.length) {
		var v = _this[_g1];
		++_g1;
		if(sys_FileSystem.isDirectory("" + outBgPath + "/" + v) ? false : true) {
			_g.push(v);
		}
	}
	var _g1 = [];
	var _g2 = 0;
	while(_g2 < _g.length) {
		var v = _g[_g2];
		++_g2;
		if(StringTools.startsWith(v,"bg")) {
			_g1.push(v);
		}
	}
	var _this = js_node_Fs.readdirSync(outPath);
	var _g = [];
	var _g2 = 0;
	while(_g2 < _this.length) {
		var v = _this[_g2];
		++_g2;
		if(sys_FileSystem.isDirectory("" + outBgPath + "/" + v) ? false : true) {
			_g.push(v);
		}
	}
	var _g2 = [];
	var _g3 = 0;
	while(_g3 < _g.length) {
		var v = _g[_g3];
		++_g3;
		if(StringTools.startsWith(v,"res")) {
			_g2.push(v);
		}
	}
	var hxml = js_node_Fs.readFileSync(hxmlPath,{ encoding : "utf8"});
	var lines = hxml.split("\n");
	if(lines.indexOf("# IMAGES") == -1 || lines.indexOf("# ATLASES") == -1 || lines.indexOf("# END") == -1) {
		console.log("# IMAGES / # ATLASES / # END blocks not found in build-resources.hxml");
		return;
	}
	var imagesBlockId = lines.indexOf("# IMAGES");
	var atlasesBlockId = lines.indexOf("# ATLASES");
	var endBlockId = lines.indexOf("# END");
	if(imagesBlockId >= atlasesBlockId || atlasesBlockId >= endBlockId) {
		console.log("" + hxmlName + " generator blocks should be in order:");
		console.log("# IMAGES ... # ATLASES ... # END");
		return;
	}
	var i = imagesBlockId + 1;
	lines.splice(i,endBlockId - imagesBlockId - 1);
	var _g = 0;
	while(_g < _g1.length) {
		var bg = _g1[_g];
		++_g;
		var tmp = "--resource res/" + bg + "@" + haxe_io_Path.withoutDirectory(haxe_io_Path.withoutExtension(bg));
		lines.splice(i,0,tmp);
		++i;
	}
	lines.splice(i,0,"# ATLASES");
	++i;
	var _g = 0;
	while(_g < _g2.length) {
		lines.splice(i,0,"--resource res/atlases/" + _g2[_g++]);
		++i;
	}
	js_node_Fs.writeFileSync(hxmlPath,lines.join("\n"));
	var _g = [];
	var _g1 = 0;
	while(_g1 < _g2.length) {
		var v = _g2[_g1];
		++_g1;
		if(StringTools.endsWith(v,".png")) {
			_g.push(v);
		}
	}
	var result = new Array(_g.length);
	var _g1 = 0;
	var _g2 = _g.length;
	while(_g1 < _g2) {
		var i = _g1++;
		result[i] = haxe_io_Path.withoutExtension(_g[i]);
	}
	var _this = GenAtlas.getAtlasFolders(atlasesPath);
	var result1 = new Array(_this.length);
	var _g = 0;
	var _g1 = _this.length;
	while(_g < _g1) {
		var i = _g++;
		var s = _this[i];
		result1[i] = s.length == 0 ? "res" : "res_" + s;
	}
	var _g = 0;
	while(_g < result1.length) HxOverrides.remove(result,result1[_g++]);
	if(result.length > 0) {
		console.log("\nWarning: Custom atlases in " + outPath + "/:");
	}
	var _g = 0;
	while(_g < result.length) {
		var name = result[_g++];
		console.log(name);
	}
};
var PngDimensions = function() { };
PngDimensions.__name__ = true;
PngDimensions.calculate = function(buffer) {
	if(buffer.toString("ascii",12,16) == PngDimensions.pngFriedChunkName) {
		return { height : buffer.readUInt32BE(36), width : buffer.readUInt32BE(32)};
	}
	return { height : buffer.readUInt32BE(20), width : buffer.readUInt32BE(16)};
};
var HxOverrides = function() { };
HxOverrides.__name__ = true;
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) {
		return undefined;
	}
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(len == null) {
		len = s.length;
	} else if(len < 0) {
		if(pos == 0) {
			len = s.length + len;
		} else {
			return "";
		}
	}
	return s.substr(pos,len);
};
HxOverrides.remove = function(a,obj) {
	var i = a.indexOf(obj);
	if(i == -1) {
		return false;
	}
	a.splice(i,1);
	return true;
};
HxOverrides.now = function() {
	return Date.now();
};
Math.__name__ = true;
var StringTools = function() { };
StringTools.__name__ = true;
StringTools.startsWith = function(s,start) {
	if(s.length >= start.length) {
		return s.lastIndexOf(start,0) == 0;
	} else {
		return false;
	}
};
StringTools.endsWith = function(s,end) {
	var elen = end.length;
	var slen = s.length;
	if(slen >= elen) {
		return s.indexOf(end,slen - elen) == slen - elen;
	} else {
		return false;
	}
};
StringTools.isSpace = function(s,pos) {
	var c = HxOverrides.cca(s,pos);
	if(!(c > 8 && c < 14)) {
		return c == 32;
	} else {
		return true;
	}
};
StringTools.ltrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,r)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,r,l - r);
	} else {
		return s;
	}
};
StringTools.rtrim = function(s) {
	var l = s.length;
	var r = 0;
	while(r < l && StringTools.isSpace(s,l - r - 1)) ++r;
	if(r > 0) {
		return HxOverrides.substr(s,0,l - r);
	} else {
		return s;
	}
};
StringTools.trim = function(s) {
	return StringTools.ltrim(StringTools.rtrim(s));
};
var haxe_Exception = function(message,previous,native) {
	Error.call(this,message);
	this.message = message;
	this.__previousException = previous;
	this.__nativeException = native != null ? native : this;
};
haxe_Exception.__name__ = true;
haxe_Exception.caught = function(value) {
	if(((value) instanceof haxe_Exception)) {
		return value;
	} else if(((value) instanceof Error)) {
		return new haxe_Exception(value.message,null,value);
	} else {
		return new haxe_ValueException(value,null,value);
	}
};
haxe_Exception.thrown = function(value) {
	if(((value) instanceof haxe_Exception)) {
		return value.get_native();
	} else if(((value) instanceof Error)) {
		return value;
	} else {
		var e = new haxe_ValueException(value);
		return e;
	}
};
haxe_Exception.__super__ = Error;
haxe_Exception.prototype = $extend(Error.prototype,{
	unwrap: function() {
		return this.__nativeException;
	}
	,get_native: function() {
		return this.__nativeException;
	}
});
var haxe_ValueException = function(value,previous,native) {
	haxe_Exception.call(this,String(value),previous,native);
	this.value = value;
};
haxe_ValueException.__name__ = true;
haxe_ValueException.__super__ = haxe_Exception;
haxe_ValueException.prototype = $extend(haxe_Exception.prototype,{
	unwrap: function() {
		return this.value;
	}
});
var haxe_crypto_Md5 = function() {
};
haxe_crypto_Md5.__name__ = true;
haxe_crypto_Md5.encode = function(s) {
	var m = new haxe_crypto_Md5();
	return m.hex(m.doEncode(haxe_crypto_Md5.str2blks(s)));
};
haxe_crypto_Md5.str2blks = function(str) {
	var str1 = haxe_io_Bytes.ofString(str);
	var nblk = (str1.length + 8 >> 6) + 1;
	var blks = [];
	var blksSize = nblk * 16;
	var _g = 0;
	while(_g < blksSize) blks[_g++] = 0;
	var i = 0;
	var max = str1.length;
	var l = max * 8;
	while(i < max) {
		blks[i >> 2] |= str1.b[i] << (l + i) % 4 * 8;
		++i;
	}
	blks[i >> 2] |= 128 << (l + i) % 4 * 8;
	var k = nblk * 16 - 2;
	blks[k] = l & 255;
	blks[k] = (blks[k] |= (l >>> 8 & 255) << 8) | (l >>> 16 & 255) << 16;
	blks[k] |= (l >>> 24 & 255) << 24;
	return blks;
};
haxe_crypto_Md5.prototype = {
	bitOR: function(a,b) {
		return (a >>> 1 | b >>> 1) << 1 | (a & 1 | b & 1);
	}
	,bitXOR: function(a,b) {
		return (a >>> 1 ^ b >>> 1) << 1 | a & 1 ^ b & 1;
	}
	,bitAND: function(a,b) {
		return (a >>> 1 & b >>> 1) << 1 | a & 1 & (b & 1);
	}
	,addme: function(x,y) {
		var lsw = (x & 65535) + (y & 65535);
		return (x >> 16) + (y >> 16) + (lsw >> 16) << 16 | lsw & 65535;
	}
	,hex: function(a) {
		var str = "";
		var _g = 0;
		while(_g < a.length) {
			var num = a[_g];
			++_g;
			str += "0123456789abcdef".charAt(num >> 4 & 15) + "0123456789abcdef".charAt(num & 15);
			str += "0123456789abcdef".charAt(num >> 12 & 15) + "0123456789abcdef".charAt(num >> 8 & 15);
			str += "0123456789abcdef".charAt(num >> 20 & 15) + "0123456789abcdef".charAt(num >> 16 & 15);
			str += "0123456789abcdef".charAt(num >> 28 & 15) + "0123456789abcdef".charAt(num >> 24 & 15);
		}
		return str;
	}
	,rol: function(num,cnt) {
		return num << cnt | num >>> 32 - cnt;
	}
	,cmn: function(q,a,b,x,s,t) {
		return this.addme(this.rol(this.addme(this.addme(a,q),this.addme(x,t)),s),b);
	}
	,ff: function(a,b,c,d,x,s,t) {
		return this.cmn(this.bitOR(this.bitAND(b,c),this.bitAND(~b,d)),a,b,x,s,t);
	}
	,gg: function(a,b,c,d,x,s,t) {
		return this.cmn(this.bitOR(this.bitAND(b,d),this.bitAND(c,~d)),a,b,x,s,t);
	}
	,hh: function(a,b,c,d,x,s,t) {
		return this.cmn(this.bitXOR(this.bitXOR(b,c),d),a,b,x,s,t);
	}
	,ii: function(a,b,c,d,x,s,t) {
		return this.cmn(this.bitXOR(c,this.bitOR(b,~d)),a,b,x,s,t);
	}
	,doEncode: function(x) {
		var a = 1732584193;
		var b = -271733879;
		var c = -1732584194;
		var d = 271733878;
		var i = 0;
		while(i < x.length) {
			var olda = a;
			var oldb = b;
			var oldc = c;
			var oldd = d;
			a = this.ff(a,b,c,d,x[i],7,-680876936);
			d = this.ff(d,a,b,c,x[i + 1],12,-389564586);
			c = this.ff(c,d,a,b,x[i + 2],17,606105819);
			b = this.ff(b,c,d,a,x[i + 3],22,-1044525330);
			a = this.ff(a,b,c,d,x[i + 4],7,-176418897);
			d = this.ff(d,a,b,c,x[i + 5],12,1200080426);
			c = this.ff(c,d,a,b,x[i + 6],17,-1473231341);
			b = this.ff(b,c,d,a,x[i + 7],22,-45705983);
			a = this.ff(a,b,c,d,x[i + 8],7,1770035416);
			d = this.ff(d,a,b,c,x[i + 9],12,-1958414417);
			c = this.ff(c,d,a,b,x[i + 10],17,-42063);
			b = this.ff(b,c,d,a,x[i + 11],22,-1990404162);
			a = this.ff(a,b,c,d,x[i + 12],7,1804603682);
			d = this.ff(d,a,b,c,x[i + 13],12,-40341101);
			c = this.ff(c,d,a,b,x[i + 14],17,-1502002290);
			b = this.ff(b,c,d,a,x[i + 15],22,1236535329);
			a = this.gg(a,b,c,d,x[i + 1],5,-165796510);
			d = this.gg(d,a,b,c,x[i + 6],9,-1069501632);
			c = this.gg(c,d,a,b,x[i + 11],14,643717713);
			b = this.gg(b,c,d,a,x[i],20,-373897302);
			a = this.gg(a,b,c,d,x[i + 5],5,-701558691);
			d = this.gg(d,a,b,c,x[i + 10],9,38016083);
			c = this.gg(c,d,a,b,x[i + 15],14,-660478335);
			b = this.gg(b,c,d,a,x[i + 4],20,-405537848);
			a = this.gg(a,b,c,d,x[i + 9],5,568446438);
			d = this.gg(d,a,b,c,x[i + 14],9,-1019803690);
			c = this.gg(c,d,a,b,x[i + 3],14,-187363961);
			b = this.gg(b,c,d,a,x[i + 8],20,1163531501);
			a = this.gg(a,b,c,d,x[i + 13],5,-1444681467);
			d = this.gg(d,a,b,c,x[i + 2],9,-51403784);
			c = this.gg(c,d,a,b,x[i + 7],14,1735328473);
			b = this.gg(b,c,d,a,x[i + 12],20,-1926607734);
			a = this.hh(a,b,c,d,x[i + 5],4,-378558);
			d = this.hh(d,a,b,c,x[i + 8],11,-2022574463);
			c = this.hh(c,d,a,b,x[i + 11],16,1839030562);
			b = this.hh(b,c,d,a,x[i + 14],23,-35309556);
			a = this.hh(a,b,c,d,x[i + 1],4,-1530992060);
			d = this.hh(d,a,b,c,x[i + 4],11,1272893353);
			c = this.hh(c,d,a,b,x[i + 7],16,-155497632);
			b = this.hh(b,c,d,a,x[i + 10],23,-1094730640);
			a = this.hh(a,b,c,d,x[i + 13],4,681279174);
			d = this.hh(d,a,b,c,x[i],11,-358537222);
			c = this.hh(c,d,a,b,x[i + 3],16,-722521979);
			b = this.hh(b,c,d,a,x[i + 6],23,76029189);
			a = this.hh(a,b,c,d,x[i + 9],4,-640364487);
			d = this.hh(d,a,b,c,x[i + 12],11,-421815835);
			c = this.hh(c,d,a,b,x[i + 15],16,530742520);
			b = this.hh(b,c,d,a,x[i + 2],23,-995338651);
			a = this.ii(a,b,c,d,x[i],6,-198630844);
			d = this.ii(d,a,b,c,x[i + 7],10,1126891415);
			c = this.ii(c,d,a,b,x[i + 14],15,-1416354905);
			b = this.ii(b,c,d,a,x[i + 5],21,-57434055);
			a = this.ii(a,b,c,d,x[i + 12],6,1700485571);
			d = this.ii(d,a,b,c,x[i + 3],10,-1894986606);
			c = this.ii(c,d,a,b,x[i + 10],15,-1051523);
			b = this.ii(b,c,d,a,x[i + 1],21,-2054922799);
			a = this.ii(a,b,c,d,x[i + 8],6,1873313359);
			d = this.ii(d,a,b,c,x[i + 15],10,-30611744);
			c = this.ii(c,d,a,b,x[i + 6],15,-1560198380);
			b = this.ii(b,c,d,a,x[i + 13],21,1309151649);
			a = this.ii(a,b,c,d,x[i + 4],6,-145523070);
			d = this.ii(d,a,b,c,x[i + 11],10,-1120210379);
			c = this.ii(c,d,a,b,x[i + 2],15,718787259);
			b = this.ii(b,c,d,a,x[i + 9],21,-343485551);
			a = this.addme(a,olda);
			b = this.addme(b,oldb);
			c = this.addme(c,oldc);
			d = this.addme(d,oldd);
			i += 16;
		}
		return [a,b,c,d];
	}
};
var haxe_io_Bytes = function(data) {
	this.length = data.byteLength;
	this.b = new Uint8Array(data);
	this.b.bufferValue = data;
	data.hxBytes = this;
	data.bytes = this.b;
};
haxe_io_Bytes.__name__ = true;
haxe_io_Bytes.ofString = function(s,encoding) {
	if(encoding == haxe_io_Encoding.RawNative) {
		var buf = new Uint8Array(s.length << 1);
		var _g = 0;
		var _g1 = s.length;
		while(_g < _g1) {
			var i = _g++;
			var c = s.charCodeAt(i);
			buf[i << 1] = c & 255;
			buf[i << 1 | 1] = c >> 8;
		}
		return new haxe_io_Bytes(buf.buffer);
	}
	var a = [];
	var i = 0;
	while(i < s.length) {
		var c = s.charCodeAt(i++);
		if(55296 <= c && c <= 56319) {
			c = c - 55232 << 10 | s.charCodeAt(i++) & 1023;
		}
		if(c <= 127) {
			a.push(c);
		} else if(c <= 2047) {
			a.push(192 | c >> 6);
			a.push(128 | c & 63);
		} else if(c <= 65535) {
			a.push(224 | c >> 12);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		} else {
			a.push(240 | c >> 18);
			a.push(128 | c >> 12 & 63);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		}
	}
	return new haxe_io_Bytes(new Uint8Array(a).buffer);
};
var haxe_io_Encoding = $hxEnums["haxe.io.Encoding"] = { __ename__:true,__constructs__:null
	,UTF8: {_hx_name:"UTF8",_hx_index:0,__enum__:"haxe.io.Encoding",toString:$estr}
	,RawNative: {_hx_name:"RawNative",_hx_index:1,__enum__:"haxe.io.Encoding",toString:$estr}
};
haxe_io_Encoding.__constructs__ = [haxe_io_Encoding.UTF8,haxe_io_Encoding.RawNative];
var haxe_io_Path = function(path) {
	switch(path) {
	case ".":case "..":
		this.dir = path;
		this.file = "";
		return;
	}
	var c1 = path.lastIndexOf("/");
	var c2 = path.lastIndexOf("\\");
	if(c1 < c2) {
		this.dir = HxOverrides.substr(path,0,c2);
		path = HxOverrides.substr(path,c2 + 1,null);
		this.backslash = true;
	} else if(c2 < c1) {
		this.dir = HxOverrides.substr(path,0,c1);
		path = HxOverrides.substr(path,c1 + 1,null);
	} else {
		this.dir = null;
	}
	var cp = path.lastIndexOf(".");
	if(cp != -1) {
		this.ext = HxOverrides.substr(path,cp + 1,null);
		this.file = HxOverrides.substr(path,0,cp);
	} else {
		this.ext = null;
		this.file = path;
	}
};
haxe_io_Path.__name__ = true;
haxe_io_Path.withoutExtension = function(path) {
	var s = new haxe_io_Path(path);
	s.ext = null;
	return s.toString();
};
haxe_io_Path.withoutDirectory = function(path) {
	var s = new haxe_io_Path(path);
	s.dir = null;
	return s.toString();
};
haxe_io_Path.directory = function(path) {
	var s = new haxe_io_Path(path);
	if(s.dir == null) {
		return "";
	}
	return s.dir;
};
haxe_io_Path.extension = function(path) {
	var s = new haxe_io_Path(path);
	if(s.ext == null) {
		return "";
	}
	return s.ext;
};
haxe_io_Path.prototype = {
	toString: function() {
		return (this.dir == null ? "" : this.dir + (this.backslash ? "\\" : "/")) + this.file + (this.ext == null ? "" : "." + this.ext);
	}
};
var haxe_iterators_ArrayIterator = function(array) {
	this.current = 0;
	this.array = array;
};
haxe_iterators_ArrayIterator.__name__ = true;
haxe_iterators_ArrayIterator.prototype = {
	hasNext: function() {
		return this.current < this.array.length;
	}
	,next: function() {
		return this.array[this.current++];
	}
};
var js_Boot = function() { };
js_Boot.__name__ = true;
js_Boot.__string_rec = function(o,s) {
	if(o == null) {
		return "null";
	}
	if(s.length >= 5) {
		return "<...>";
	}
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) {
		t = "object";
	}
	switch(t) {
	case "function":
		return "<function>";
	case "object":
		if(o.__enum__) {
			var e = $hxEnums[o.__enum__];
			var con = e.__constructs__[o._hx_index];
			var n = con._hx_name;
			if(con.__params__) {
				s = s + "\t";
				return n + "(" + ((function($this) {
					var $r;
					var _g = [];
					{
						var _g1 = 0;
						var _g2 = con.__params__;
						while(true) {
							if(!(_g1 < _g2.length)) {
								break;
							}
							var p = _g2[_g1];
							_g1 = _g1 + 1;
							_g.push(js_Boot.__string_rec(o[p],s));
						}
					}
					$r = _g;
					return $r;
				}(this))).join(",") + ")";
			} else {
				return n;
			}
		}
		if(((o) instanceof Array)) {
			var str = "[";
			s += "\t";
			var _g = 0;
			var _g1 = o.length;
			while(_g < _g1) {
				var i = _g++;
				str += (i > 0 ? "," : "") + js_Boot.__string_rec(o[i],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( _g ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString && typeof(tostr) == "function") {
			var s2 = o.toString();
			if(s2 != "[object Object]") {
				return s2;
			}
		}
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		var k = null;
		for( k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) {
			str += ", \n";
		}
		str += s + k + " : " + js_Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "string":
		return o;
	default:
		return String(o);
	}
};
var js_node_ChildProcess = require("child_process");
var js_node_Fs = require("fs");
var js_node_Path = require("path");
var sys_FileSystem = function() { };
sys_FileSystem.__name__ = true;
sys_FileSystem.exists = function(path) {
	try {
		js_node_Fs.accessSync(path);
		return true;
	} catch( _g ) {
		return false;
	}
};
sys_FileSystem.isDirectory = function(path) {
	try {
		return js_node_Fs.statSync(path).isDirectory();
	} catch( _g ) {
		return false;
	}
};
sys_FileSystem.createDirectory = function(path) {
	try {
		js_node_Fs.mkdirSync(path);
	} catch( _g ) {
		var _g1 = haxe_Exception.caught(_g).unwrap();
		if(_g1.code == "ENOENT") {
			sys_FileSystem.createDirectory(js_node_Path.dirname(path));
			js_node_Fs.mkdirSync(path);
		} else {
			var stat;
			try {
				stat = js_node_Fs.statSync(path);
			} catch( _g2 ) {
				throw _g1;
			}
			if(!stat.isDirectory()) {
				throw _g1;
			}
		}
	}
};
sys_FileSystem.deleteDirectory = function(path) {
	if(sys_FileSystem.exists(path)) {
		var _g = 0;
		var _g1 = js_node_Fs.readdirSync(path);
		while(_g < _g1.length) {
			var curPath = path + "/" + _g1[_g++];
			if(sys_FileSystem.isDirectory(curPath)) {
				sys_FileSystem.deleteDirectory(curPath);
			} else {
				js_node_Fs.unlinkSync(curPath);
			}
		}
		js_node_Fs.rmdirSync(path);
	}
};
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $global.$haxeUID++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = m.bind(o); o.hx__closures__[m.__id__] = f; } return f; }
$global.$haxeUID |= 0;
if(typeof(performance) != "undefined" ? typeof(performance.now) == "function" : false) {
	HxOverrides.now = performance.now.bind(performance);
}
String.__name__ = true;
Array.__name__ = true;
Date.__name__ = "Date";
js_Boot.__toStr = ({ }).toString;
PngDimensions.pngFriedChunkName = "CgBI";
GenAtlas.main();
})(typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this);
