package game;

typedef FrameConfig = {
	var ?set:String;
	var ?id:Int;
	var ?delay:Int;
	var ?loop:Bool;
	var ?atEnd:String;
}

typedef Frameset = {
	var ids:Array<Int>;
	var delay:Int;
	var loop:Bool;
	var ?atEnd:String;
}

class Anim {
	public var frameI = 0;

	var framesets = new Map<String, Frameset>();
	var frameDelay = 0;

	public var frameType(default, null):String;

	var frameTypeI:Int;

	public function new(frames:Array<FrameConfig>) {
		var curSet = "none";
		var delay = 1;
		var loop = true;
		var curId = 0;
		for (i => frame in frames) {
			if (frame.delay != null) delay = frame.delay;
			if (frame.loop != null) loop = frame.loop;
			if (frame.set != null) {
				curSet = frame.set;
				framesets[curSet] = {
					delay: delay,
					ids: [],
					loop: loop,
					atEnd: frame.atEnd
				};
			}
			if (frame.id != null) curId = frame.id;
			framesets[curSet].ids.push(curId);
			curId++;
		}
	}

	public function setType(type:String):Void {
		if (frameType == type) return;
		frameType = type;
		frameTypeI = 0;
		final set = framesets[frameType];
		frameI = set.ids[0];
		// frameDelay = set.delay - 1;
		frameDelay = 0;
	}

	public function playType(delayMult = 1):Void {
		frameDelay++;
		final set = framesets[frameType];
		if (frameDelay < set.delay * delayMult) return;
		frameTypeI++;
		final length = set.ids.length;
		if (frameTypeI == length) {
			if (set.loop) frameTypeI = 0;
			else {
				if (set.atEnd != null) {
					setType(set.atEnd);
					return;
				}
				frameTypeI--;
			}
		}
		frameI = set.ids[frameTypeI];
		frameDelay = 0;
	}
}
