package game;

import khm.Container;
import khm.Lazyr;
import khm.Particles;
import khm.Res.res;
import khm.Res;
import khm.Sprite;

class Checkpoint extends Container {
	var line:Sprite;
	var line2:Sprite;

	public function new() {
		super();
		setSize(16, 16);
		line = addSprite(res.tile_line);
		line.tint = 0xAA249fde;
		line.y = 8;
		line2 = addSprite(res.tile_line);
		line2.tint = 0x80249fde;
		line2.y = line.y - 1;
		final particles = addParticles({
			frames: [Res.res.pixel_particle],
			emitCallback: particle -> {
				particle.tint = 0xFF20d6c7;
				particle.x = Std.random(16) - 8;
			},
			lifespan: 1500,
			speed: {min: 5, max: 10},
			// angle: -90,
			angle: {min: -90 + 10, max: -90 + 15},
			// gravityY: -5,
			alpha: {start: 1, end: 0},
		});
		particles.y = line.y;
		particles.flow(300, 1);
		addAt(0, particles);

		// delayed(1000, () -> activate());
	}

	public function activate():Void {
		Lazyr.tweenTint(line, {
			duration: 300,
			end: 0xFF20d6c7,
			yoyo: true
		});
		Lazyr.tweenTint(line2, {
			duration: 300,
			end: 0x8820d6c7,
			yoyo: true
		});
		final particles = addParticles({
			frames: [Res.res.pixel_particle],
			emitCallback: particle -> {
				particle.tint = 0xFF20d6c7;
				particle.x = Std.random(16) - 8;
			},
			lifespan: 1500,
			speed: {min: 5, max: 20},
			// angle: -90,
			angle: {min: -90 + 10, max: -90 + 15},
			// gravityY: -5,
			alpha: {start: 1, end: 0},
		});
		particles.y = line.y;
		particles.explode(30, 0, 0);
	}
}
