package game;

import khm.App;
import khm.AudioRes;
import khm.Lazyr;
import khm.Res.res;
import khm.Scene;
import khm.Sprite;
import khm.Text;
import khm.utils.Base64Loader;

class Loader extends Scene {
	final onLoad:(loader:Loader) -> Void;
	var cursor:Cursor;
	var text:Text;

	public function new(onLoad:(loader:Loader) -> Void) {
		super();
		this.onLoad = onLoad;
		load();
	}

	function load():Void {
		var splash:Sprite = null;
		final onAudioInited = () -> {
			Lazyr.isAudioInited = true;
			// music = Lazyr.addAudioSprite(AudioRes.music, {
			// 	loop: true,
			// 	volume: 0.4,
			// });
			// final music = Lazyr.addAudioSprite(AudioRes.music_ney, {
			// 	loop: true
			// });
			trace("onAudioInited");
		}
		App.defaultScaleQuality = Low;
		Base64Loader.loadBase64Resources(this, {
			onImagesLoaded: config -> {
				cursor = new Cursor(cast this);
				this.add(cursor);
				cursor.scale = 5;
				cursor.x = App.w / 2;
				cursor.y = App.h / 2;
				cursor.playAnim();

				text = addText({
					text: "Загрузка...",
					style: {
						color: White,
						fontSize: 30
					},
				});
				text.alpha = 0;
				text.showAnim(500, 500);
				shrink();
			},
			onAudioInited: onAudioInited,
			onComplete: () -> {
				// todo rm
				// Lazyr.isAudioInited = false;
				// onLoad(this);
				// return;
				#if (kha && !no_sound)
				kha.Assets.loadEverything(
					() -> {
						Lazyr.isAudioInited = true;
						onLoad(this);
					},
					item -> item.type == "sound",
					// soundItem -> !soundItem.name.startsWith("music"),
				);
				#else
				onLoad(this);
				#end
			},
			completeBeforeAudio: true
		});
	}

	override function onUpdate() {
		if (cursor == null) return;
		cursor.x = App.w / 2;
		cursor.y = App.h / 2;
		cursor?.update();
		text.x = cursor.x;
		text.y = cursor.y + 100;
	}
}
