package game;

import game.TileState.TileMoveState;
import khm.tilemap.Tile;

class TileTools {
	public static function getType(tile:Tile):TileType {
		return cast tile.id;
	}

	public static function getState(tile:Tile):TileState {
		tile.state.init();
		return cast tile.state;
	}

	public static function isActivatableType(tile:Tile):Bool {
		final type = tile.getType();
		return switch type {
			case MovingBlock, JumpPadInactive, JumpPadActive, PlatformCallerInactive: true;
			case _: false;
		}
	}

	public static function getTileMoveState(tile:Tile):TileMoveState {
		return switch tile.getType() {
			case MovingBlockInactive, MovingBlock:
				tile.getState().movingBlock.moveState;
			case JumpPadInactive, JumpPadActive:
				tile.getState().jumpPad.moveState;
			case PlatformCallerInactive, PlatformCallerActive:
				tile.getState().tileButton.moveState;
			case ElevatorBlock:
				Inactive;
		}
	}

	public static function getTileInitialState(tile:Tile):TileMoveState {
		return switch tile.getType() {
			case MovingBlockInactive, MovingBlock:
				tile.getState().movingBlock.initialState;
			case JumpPadInactive, JumpPadActive:
				tile.getState().jumpPad.initialState;
			case PlatformCallerInactive, PlatformCallerActive:
				tile.getState().tileButton.initialState;
			case ElevatorBlock:
				Inactive;
		}
	}
}
